#include <Adafruit_NeoPixel.h>

#define PIN1      13
#define PIN2      12
#define PIN3      14
#define NUM_LEDS 45

Adafruit_NeoPixel strip1 = Adafruit_NeoPixel(NUM_LEDS, PIN1, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel strip2 = Adafruit_NeoPixel(NUM_LEDS, PIN2, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel strip3 = Adafruit_NeoPixel(NUM_LEDS, PIN3, NEO_GRB + NEO_KHZ800);

void setup() {
  strip1.begin();
  strip1.show(); // Initialize all pixels to 'off'
  strip2.begin();
  strip2.show(); // Initialize all pixels to 'off'
  strip3.begin();
  strip3.show(); // Initialize all pixels to 'off'
}

void loop() {
  // List of colors to fade through (8 tones)
  uint32_t colors[] = {strip1.Color(255, 0, 0), strip1.Color(255, 165, 0), strip1.Color(255, 255, 0), strip1.Color(0, 128, 0), strip1.Color(0, 0, 255), strip1.Color(75, 0, 130), strip1.Color(143, 0, 255), strip1.Color(255, 0, 255)};
  
  for (int j = 0; j < 8; j++) {
    for (int k = 0; k < 256; k++) {
      for (uint16_t i = 0; i < strip1.numPixels(); i++) {
        strip1.setPixelColor(i, Wheel((i + k) % 255, colors[j]));
        strip2.setPixelColor(i, Wheel((i + k + 85) % 255, colors[j])); // Offset by 85
        strip3.setPixelColor(i, Wheel((i + k + 170) % 255, colors[j])); // Offset by 170
      }
      strip1.show();
      strip2.show();
      strip3.show();
      delay(20);
    }
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos, uint32_t color) {
  WheelPos = 255 - WheelPos;
  if (WheelPos < 85) {
    return strip1.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if (WheelPos < 170) {
    WheelPos -= 85;
    return strip1.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip1.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}
